diff --git a/web/pgadmin/static/js/components/CodeMirror.jsx b/web/pgadmin/static/js/components/CodeMirror.jsx
index ede3eca5..9f4908bd 100644
--- a/web/pgadmin/static/js/components/CodeMirror.jsx
+++ b/web/pgadmin/static/js/components/CodeMirror.jsx
@@ -330,7 +330,7 @@ function handlePaste(editor, e) {
 }
 
 /* React wrapper for CodeMirror */
-export default function CodeMirror({currEditor, name, value, options, events, readonly, disabled, className, autocomplete=false}) {
+export default function CodeMirror({currEditor, name, value, options, events, readonly, disabled, className, autocomplete=false, gutters=['CodeMirror-linenumbers', 'CodeMirror-foldgutter']}) {
   const taRef = useRef();
   const editor = useRef();
   const cmWrapper = useRef();
@@ -355,7 +355,7 @@ export default function CodeMirror({currEditor, name, value, options, events, re
         widget: '\u2026',
       },
       foldGutter: true,
-      gutters: ['CodeMirror-linenumbers', 'CodeMirror-foldgutter'],
+      gutters: gutters,
       extraKeys: {
         // Autocomplete sql command
         ...(autocomplete ? {
@@ -416,22 +416,6 @@ export default function CodeMirror({currEditor, name, value, options, events, re
     }
 
     Object.keys(events||{}).forEach((eventName)=>{
-      if(eventName === 'change') {
-        let timeoutId;
-        const change = (...args)=>{
-          /* In case of indent, change is triggered for each line */
-          /* This can be avoided and taking only the latest */
-          if(timeoutId) {
-            clearTimeout(timeoutId);
-          }
-          timeoutId = setTimeout(()=>{
-            events[eventName](...args);
-            timeoutId = null;
-          }, 0);
-        };
-        editor.current.on(eventName, change);
-        return;
-      }
       editor.current.on(eventName, events[eventName]);
     });
     editor.current.on('drop', handleDrop);
@@ -531,4 +515,5 @@ CodeMirror.propTypes = {
   disabled: PropTypes.bool,
   className: CustomPropTypes.className,
   autocomplete: PropTypes.bool,
+  gutters: PropTypes.array
 };
diff --git a/web/pgadmin/static/js/helpers/ModalProvider.jsx b/web/pgadmin/static/js/helpers/ModalProvider.jsx
index 05f0dc07..5a1d9900 100644
--- a/web/pgadmin/static/js/helpers/ModalProvider.jsx
+++ b/web/pgadmin/static/js/helpers/ModalProvider.jsx
@@ -172,6 +172,7 @@ function PaperComponent(props) {
       <Rnd
         size={props.isfullscreen == 'true' && { width: '100%', height: '100%' }}
         className={clsx(classes.dialog, props.isfullscreen == 'true' ? classes.fullScreen : '')}
+        positionOffset={{x: '-10%', y: '-10%'}}
         default={{
           x: 300,
           y: 100,
diff --git a/web/pgadmin/tools/debugger/__init__.py b/web/pgadmin/tools/debugger/__init__.py
index e1351685..c893e08d 100644
--- a/web/pgadmin/tools/debugger/__init__.py
+++ b/web/pgadmin/tools/debugger/__init__.py
@@ -9,6 +9,7 @@
 
 """A blueprint module implementing the debugger"""
 
+import pickle
 import simplejson as json
 import random
 import re
@@ -65,9 +66,10 @@ class DebuggerModule(PgAdminModule):
     def get_own_javascripts(self):
         scripts = list()
         for name, script in [
+            ['pgadmin.tools.debugger', 'js/index'],
             ['pgadmin.tools.debugger.controller', 'js/debugger'],
             ['pgadmin.tools.debugger.ui', 'js/debugger_ui'],
-            ['pgadmin.tools.debugger.direct', 'js/direct']
+            # ['pgadmin.tools.debugger.direct', 'js/direct']
         ]:
             scripts.append({
                 'name': name,
@@ -266,15 +268,15 @@ def index():
     )
 
 
-@blueprint.route("/js/debugger.js")
-@login_required
-def script():
-    """render the main debugger javascript file"""
-    return Response(
-        response=render_template("debugger/js/debugger.js", _=gettext),
-        status=200,
-        mimetype=MIMETYPE_APP_JS
-    )
+# @blueprint.route("/js/debugger.js")
+# @login_required
+# def script():
+#     """render the main debugger javascript file"""
+#     return Response(
+#         response=render_template("debugger/js/debugger.js", _=gettext),
+#         status=200,
+#         mimetype=MIMETYPE_APP_JS
+#     )
 
 
 @blueprint.route("/js/debugger_ui.js")
@@ -288,7 +290,7 @@ def script_debugger_js():
     )
 
 
-@blueprint.route("/js/direct.js")
+@blueprint.route("/js/debugger.js")
 @login_required
 def script_debugger_direct_js():
     """
@@ -296,7 +298,7 @@ def script_debugger_direct_js():
     from server for debugging
     """
     return Response(
-        response=render_template("debugger/js/direct.js", _=gettext),
+        response=render_template("debugger/js/debugger.js", _=gettext),
         status=200,
         mimetype=MIMETYPE_APP_JS
     )
@@ -885,7 +887,7 @@ def initialize_target(debug_type, trans_id, sid, did,
     # be be required
     if request.method == 'POST':
         de_inst.function_data['args_value'] = \
-            json.loads(request.values['data'], encoding='utf-8')
+            json.loads(request.data, encoding='utf-8')
 
     # Update the debugger data session variable
     # Here frame_id is required when user debug the multilevel function.
@@ -1562,10 +1564,17 @@ def clear_all_breakpoint(trans_id):
     else:
         template_path = DEBUGGER_SQL_V3_PATH
 
+    status = True
+    result = ''
     if conn.connected():
         # get the data sent through post from client
-        if request.form['breakpoint_list']:
-            line_numbers = request.form['breakpoint_list'].split(",")
+        if 'breakpoint_list' in json.loads(request.data):
+            if json.loads(request.data)['breakpoint_list'] is not None:
+                line_numbers = json.loads(request.data)[
+                    'breakpoint_list'].split(",")
+            else:
+                []
+
             for line_no in line_numbers:
                 sql = render_template(
                     "/".join([template_path, "clear_breakpoint.sql"]),
@@ -1629,7 +1638,7 @@ def deposit_parameter_value(trans_id):
 
     if conn.connected():
         # get the data sent through post from client
-        data = json.loads(request.values['data'], encoding='utf-8')
+        data = json.loads(request.data, encoding='utf-8')
 
         if data:
             sql = render_template(
@@ -1842,8 +1851,8 @@ def set_arguments_sqlite(sid, did, scid, func_id):
         - Function Id
     """
 
-    if request.values['data']:
-        data = json.loads(request.values['data'], encoding='utf-8')
+    if request.data:
+        data = json.loads(request.data, encoding='utf-8')
 
     try:
         for i in range(0, len(data)):
diff --git a/web/pgadmin/tools/debugger/static/js/DebuggerConstants.js b/web/pgadmin/tools/debugger/static/js/DebuggerConstants.js
new file mode 100644
index 00000000..c014e245
--- /dev/null
+++ b/web/pgadmin/tools/debugger/static/js/DebuggerConstants.js
@@ -0,0 +1,50 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+export const DEBUGGER_EVENTS = {
+  TRIGGER_CLEAR_ALL_BREAKPOINTS: 'TRIGGER_CLEAR_ALL_BREAKPOINTS',
+  TRIGGER_TOGGLE_BREAKPOINTS: 'TRIGGER_TOGGLE_BREAKPOINTS',
+  TRIGGER_STOP_DEBUGGING: 'TRIGGER_STOP_DEBUGGING',
+  TRIGGER_CONTINUE_DEBUGGING: 'TRIGGER_CONTINUE_DEBUGGING',
+  TRIGGER_STEPOVER_DEBUGGING: 'TRIGGER_STEPOVER_DEBUGGING',
+  TRIGGER_STEINTO_DEBUGGING: 'TRIGGER_STEINTO_DEBUGGING',
+
+  SET_STACK: 'SET_STACK',
+  SET_MESSAGES: 'SET_MESSAGES',
+  SET_RESULTS: 'SET_RESULTS',
+  SET_LOCAL_VARIABLES: 'SET_LOCAL_VARIABLES',
+  SET_PARAMETERS: 'SET_PARAMETERS',
+  SET_FRAME: 'SET_FRAME',
+
+  SET_LOCAL_VARIABLE_VALUE_CHANGE: 'SET_LOCAL_VARIABLE_VALUE_CHANGE',
+  SET_PARAMETERS_VALUE_CHANGE: 'SET_PARAMETERS_VALUE_CHANGE',
+
+  DISABLE_MENU: 'DISABLE_MENU',
+  ENABLE_MENU: 'ENABLE_MENU',
+  ENABLE_SPECIFIC_MENU: 'ENABLE_SPECIFIC_MENU',
+
+  FOCUS_PANEL: 'FOCUS_PANEL',
+};
+
+export const PANELS = {
+  DEBUGGER: 'id-debugger',
+  PARAMETERS: 'id-parameters',
+  LOCAL_VARIABLES: 'id-local-variables',
+  MESSAGES: 'id-debugger-messages',
+  RESULTS: 'id-results',
+  STACK: 'id-stack',
+};
+
+export const MENUS = {
+  STEPINTO: 'step-into',
+  STEPOVER: 'step-over',
+  STOP: 'stop',
+  CONTINUE: 'continue',
+  CLEAR_ALL_BREAKPOINT: 'clear-all-breakpoint',
+  TOGGLE_BREAKPOINT: 'toggle-breakpoint'
+};
